var thumbSize = [% IF thumbSize %][% thumbSize %][% ELSE %]130[% END %];
var thumbHrefTemplate = '/music/COVER/thumb_'+thumbSize+'x'+thumbSize+'_p.jpg';

[% PROCESS html/global.js %]

var statusstub = webroot + statusroot + '?';


function globalOnload() {
//	refreshLibraryInfo();
	window.onscroll = hideBrowserBar;
	window.scrollBy (0,1);
}

function hideBrowserBar() {
		if (!window.pageYOffset) 
			window.scrollTo (0, 1);
 }

function chooseAlbumOrderBy(value, option, artwork)
{
	if (!artwork && artwork != 0) {
		artwork = 1;
	}
        var url = '[% webroot %]browsedb.html?hierarchy=[% hierarchy %]&level=[% level %][% attributes %][% IF artwork OR artwork == '0' %]&artwork='+artwork+'[% END %]&player=[% playerURI %]'; 
        if (option) {
                url = url + '&orderBy=' + option;
        }
        setCookie( 'SqueezeCenter-orderBy', option );
        window.location = url;
}

function setAlbumOrderBy(value, option)
{
    setCookie( 'SqueezeCenter-orderBy', option );
}


function setCookie(name, value) {
        var expires = new Date();
        expires.setTime(expires.getTime() + 1000*60*60*24*365);
        document.cookie =
                name + "=" + escape(value) +
                ((expires == null) ? "" : ("; expires=" + expires.toGMTString()));
}

function getCookie(param){
	var c = document.cookie + ";";
	var re = /\s?(.*?)=(.*?);/g;
	var matches;
	while((matches = re.exec(c)) != null){
		var name = matches[1];
		var value = matches[2];
		if (name == param) {
			return unescape(value);
		}
	}
	return '';
}


// enters message sent to OSD div (typically still needs to be made visible with a different function)
function changeOSD(message) {
	if ($('OSD')) {
		$('OSD').innerHTML = message;
	}
}

// send a message and number of milliseconds duration to the OSD div
function showVolumeOSD(message, duration) {
	var msDuration = parseInt(duration, 10);

	if ($('volumeOSD')) {
		$('volumeOSD').innerHTML = '';
		$('volumeOSD').style.display = 'block';
		$('volumeOSD').innerHTML = message;
	}

	var intervalID = setTimeout(hideVolumeOSD, msDuration);
}

function hideVolumeOSD() {

	if ($('volumeOSD')) {
		$('volumeOSD').style.display = 'none';
	}

}

function showAdded() {

	if ($('OSDbg')) {
	 	$('OSDbg').style.top = window.pageYOffset + 140;
		$('OSDbg').style.display = 'block';
	}
	if ($('OSD')) {
	 	$('OSD').style.top = window.pageYOffset + 140;
		$('OSD').style.display = 'block';
	}

	var intervalID = setTimeout("hideAdded()", 2000);
}

function hideAdded() {

	if ($('OSD')) {
		$('OSD').style.display = 'none';
	}
	if ($('OSDbg')) {
		$('OSDbg').style.display = 'none';
	}
}

function resize(src,width) {
	if (!width) {
		// special case for IE (argh)
		if (document.all) {
			width = document.body.clientWidth*0.5;
		} else if (document.getElementById) { //else if NS6+ 
			width = window.innerWidth*0.5;
		}
	}
	if (src.width > width ) {
		src.width = width;
	}
}

function toggleGalleryView(artwork) {
	var thisdoc = document;
	if (thisdoc.location.pathname != '') {
		myString = new String(thisdoc.location.href);
		if (artwork) {
			setCookie( 'SqueezeCenter-albumView', "1" );
			if (thisdoc.location.href.indexOf('start') == -1) {
				thisdoc.location=thisdoc.location.href+"&artwork=1";
			} else {
				myString = new String(thisdoc.location.href);
				var rExp = /\&start=/gi;
				thisdoc.location=myString.replace(rExp, "&artwork=1&start=");
			}
		} else {
			setCookie( 'SqueezeCenter-albumView', "" );
			var rExp = /\&artwork=1/gi;
			thisdoc.location=myString.replace(rExp, "");
		}
	}
}


function storeReturnLevel() {
 	var hreftmp = new String (document.location);
	var myString = '';
	var idxTemp = hreftmp.indexOf("hierarchy=");
	var hierarchy = null;
	var level = '0';
	if (idxTemp == -1) {
	 	return;
	}
	hierarchy = hreftmp.slice (idxTemp + 10); // LO("&hierarchy=")
 	idxTemp = hierarchy.indexOf ('&');
 	if (idxTemp > 0)
 		hierarchy = hierarchy.substr(0, idxTemp);
 	hierarchy = escape(hierarchy);
 	
 	idxTemp = hreftmp.indexOf("level=");
 	if (idxTemp != -1) {
		level = hreftmp.slice (idxTemp + 6); // LO ("&level=")
		idxTemp = level.indexOf ('&');
		if (idxTemp > 0)
			level = level.substr(0, idxTemp);
	}
 		
 	idxTemp = hreftmp.indexOf('start=');
	if (idxTemp != -1) {
	 	myString = hreftmp.slice (idxTemp + 6); // LO ("&start=")
	 	idxTemp = myString.indexOf ('&');
	 	if (idxTemp > 0)
	 		myString = myString.substr(0,idxTemp);
	}
	setCookie( 'SqueezeCenter-returnToH' + hierarchy + level, myString );
}

function returnToLevel(hRefParam) {
	var rExp = /\&href=/gi;			// hack to get rid of "href="
 	var param = hRefParam.replace(rExp, "");
 
	var idxTemp = param.indexOf('hierarchy=');
	if (idxTemp == -1) {
	 	document.location = param;
	 	return;		
	}
	var hierarchy = param.slice (idxTemp + 10); //LO ("&h...")
 	idxTemp = hierarchy.indexOf ('&');
 	if (idxTemp > 0)
 		hierarchy = hierarchy.substr(0, idxTemp);
 	hierarchy = escape(hierarchy);

	var level = '0';
 	idxTemp = param.indexOf('level=');
 	if (idxTemp != -1) {
		level = param.slice (idxTemp + 6);
		idxTemp = level.indexOf ('&');
		if (idxTemp > 0)
			level = level.substr(0, idxTemp);
	}
	document.location = param + "&start=" + getCookie( 'SqueezeCenter-returnToH' + hierarchy + level );
}

function storeReturnPage() {
 	var hreftmp = new String (document.location);
	setCookie( 'SqueezeCenter-returnToView', hreftmp );
}

function returnToViewPage() {
	var thisdoc = window;
	var myString = new String ( getCookie( 'SqueezeCenter-returnToView' ) );
	if (myString) {
		document.location = myString;
	}
}


function powerControl (action) {
	var args = "p0=power&p1=" + parseInt(action) + "&player=" + player + "&ajaxRequest=1";
	// always use status.html for this request
	var old_url = url;
	if (action) {
		Element.hide("powerControlOff");
		document.getElementById("powerControlOn").style.display = "block";
//		Element.show("powerControlOff");
		} else {
		Element.hide("powerControlOn");
		document.getElementById("powerControlOff").style.display = "block";
//		Element.show("miniControlPlay");
	}
	url = webroot + 'status.html';
	getStatusData(args, refreshNothing);
	url = old_url;
}


// miniControls is for putting play/pause on any page. ajax request is made via status.html
function miniControls(action) {
	var args = "p0=" + action + "&player=" + player + "&ajaxRequest=1";

	// always use status.html for this request
	var old_url = url;

	if (action == 'play') {
		Element.hide("miniControlPlay");
		document.getElementById("miniControlPause").style.display = "block";
//		Element.show("miniControlPause");
		} else {
		Element.hide("miniControlPause");
		document.getElementById("miniControlPlay").style.display = "block";
//		Element.show("miniControlPlay");
	}
	url = webroot + 'status.html';
	getStatusData(args, refreshNothing);
	url = old_url;
}


function callJSONRPC(paramArray, callback, failure, thisplayer) {
 	var thisplayer = (thisplayer == null) ?  playerid : thisplayer;
	var temp = {
	 		"id" : 1,
			"method" : "slim.request",
			"params" : [ thisplayer, paramArray ]};
//alert ("cJR:" + paramArray + '.:.' + callback + '.:.' + failure);
	new Ajax.Request ('/jsonrpc.js', {
	 		 method: 'post',
	 		 postBody: Object.toJSON(temp),
	 		 onSuccess: function (transport) {
				var response = transport.responseText.evalJSON(true);
//alert("rt:" +transport.responseText + ".:." + response);
				callback (response); },
			 onFailure: function (response) { 
			  	if (failure) failure(response); } });
}


function addItem(args) {
	getStatusData(args, showAdded);
}

function goToStatus(goStatus) {
	if (goStatus)
		document.location = statusstub + 'player=' + player;
}

function addPlayItem(args) {
// alert ("a:" + args);
//	var rExp = /\&ajaxRequest=1/gi;
//	var param = args.replace(rExp, "");
//alert ("api:" + args);
	var	param = unescape(args);
	var rExp = /\&\&+/gi;
	param = param.replace(rExp, "&");
// alert ("p:" + param);
 	var paramArray = param.split("&");
//alert ("pA:" + paramArray);
	callJSONRPC (paramArray, function (res) { goToStatus(true); });
}

function addItemLoad (args, playthis, goStatus) {
//	var rExp = /\&ajaxRequest=1/gi;
//	var param = args.replace(rExp, "");
//alert ("ail:" + args + "." + playthis + "." + goStatus);
	if (!playthis) {
		if (goStatus)
			addPlayItem(args);
		else
			new Ajax.Request ('/jsonrpc.js', { method: 'post', parameters: args});
		return;
	}
	var paramArray = ["playlist", "shuffle", "?"];
	callJSONRPC(paramArray, function (response){
		if (response.result._shuffle) {
			var paramArray = ["playlist", "shuffle", "0"];
			callJSONRPC (paramArray, function (res2) { 
			 	loadNPlay2(args, response.result._shuffle, playthis, goStatus);	});
		} else
				loadNPlay2(args, 0, playthis, goStatus);
	});
}

function loadNPlay2 (args, shuffle, playthis, goStatus) {
 	function resetShuffle(shuffle, goStatus) {
		if (shuffle) {
			var sArray = ["playlist", "shuffle", shuffle];
			callJSONRPC (sArray, function (r2) {goToStatus(goStatus);}, function (r2) {goToStatus(goStatus); });
		} else 
			goToStatus(goStatus);
	}
//alert ("inherer:" + args);
/* 	var obj = args.toQueryParams();
 	obj.player = "";
 	var param = Object.values(obj);*/
	var rExp = /\&\&+/gi;
	var ar2 = args.replace(rExp, "&");
 	var param = ar2.split("&");
//alert (param);
 	callJSONRPC (param, function (res) {
 	 	if (playthis) {
	 	 	var pArray = ["playlist", "index", playthis];
			callJSONRPC (pArray, function (r2) { resetShuffle(shuffle, goStatus); }, function (r2) { resetShuffle(shuffle, goStatus); });
		} else
			resetShuffle(shuffle, goStatus);
	});
}


function clearCurrentPlaylist() {
	if (confirm("Do You really want to clear the current playlist?")) {
		var sArray = [ 'playlist', 'clear' ];
		callJSONRPC(sArray, function (r2) { hidePlaylistControl(); }, function (r2) {});
	}
}

function showPlaylistControl() {
	if ($('currentPlaylistControl')) {
	 	if ($('alphamap'))
	 		$('alphamap').style.top = 98;
		Element.show('currentPlaylistControl');
	}
}

function hidePlaylistControl() {
	if ($('currentPlaylistControl')) {
	 	if ($('alphamap'))
	 		$('alphamap').style.top = 50;
		Element.hide('currentPlaylistControl');
	}
}

function evaluatePlaylist() {
	var sArray = [ 'playlist', 'tracks', '?' ];
	callJSONRPC(sArray, function (r2) {
	 		if (r2.result._tracks > 0) {
		 		showPlaylistControl();
				var sArr = [ 'playlist', 'name', '?' ];
				callJSONRPC(sArr, function (r3) { 
				 		if ($('curr_playlistname'))
							if (r3.result._name)
								refreshElement('curr_playlistname', r3.result._name, 26);
							else
								refreshElement('curr_playlistname', 'unnamed playlist');
							
					}, function (r3) {});
	 		} else
	 			hidePlaylistControl();
		}, function (r2) {});
}

function scrollOverlayUp(id1, id2, offset, onflag) {
	var page1 = $(id1);
	var page2 = id2 ? $(id2) : page1;
	var interval = (onflag) ? -104 : 104;
	var starttop = (onflag) ? 416 : 0;
	var endtop = (onflag) ? 0 : 416;
	
	page1.style.top = starttop + offset;
	page2.style.top = starttop + offset;
	if (onflag) {
		Element.show(id1);
		Element.show(id2);
	}
	
	var timer = setInterval (doScroll, 0);

	function doScroll () {
		if (starttop != endtop) {
			starttop += interval;
			page1.style.top = starttop + offset;
			page2.style.top = starttop + offset;
		}
		else {
			clearInterval(timer);
			if (!onflag) {
				Element.hide(id1);
				Element.hide(id2);
			}
		}
	}
}
